// Definitions for CINT and PYTHON interface of tuples
// For info have a look at
// https://root.cern.ch/selecting-dictionary-entries-linkdefh
// https://root.cern.ch/root/htmldoc/guides/users-guide/AddingaClass.html#other-useful-pragma-statements
#include "RooDoubleCB.h"
#include "RooDoubleSidedCBShape.h"
#include "RooExpAndGauss.h"
#include "RooExpGaussExp.h"
#include "RooInverseArgus.h"
#include "RooInverseGumbel.h"
#include "RooIpatia.h"
#include "RooIpatia2.h"
#include "RooMultiVarGaussianSuppressWarning.h"

#ifdef __ROOTCLING__

#pragma link off all class;
//#pragma link off all enum;
//#pragma link off all function;
//#pragma link off all global;
#pragma link off all namespace;
//#pragma link off all struct;
//#pragma link off all typedef;
//#pragma link off all union;

#pragma link C++ nestedclasses;
#pragma link C++ nestedtypedef;

#pragma link C++ class RooDoubleCB+;
#pragma link C++ defined_in "RooDoubleCB.h";

#pragma link C++ class RooExpAndGauss+;
#pragma link C++ defined_in "RooExpAndGauss.h";

#pragma link C++ class RooIpatia+;
#pragma link C++ defined_in "RooIpatia.h";

#pragma link C++ class RooIpatia2+;
#pragma link C++ defined_in "RooIpatia2.h";

#pragma link C++ class RooExpGaussExp+;
#pragma link C++ defined_in "RooExpGaussExp.h";

#pragma link C++ class RooInverseArgus+;
#pragma link C++ defined_in "RooInverseArgus.h";

#pragma link C++ class RooInverseGumbel+;
#pragma link C++ defined_in "RooInverseGumbel.h";

#pragma link C++ class RooDoubleSidedCBShape+;
#pragma link C++ defined_in "RooDoubleSidedCBShape.h";

#pragma link C++ class RooMultiVarGaussianSuppressWarning+;
#pragma link C++ defined_in "RooMultiVarGaussianSuppressWarning.h";

// #pragma link C++ class RooHypatia+;
// #pragma link C++ defined_in "RooHypatia.h";
#endif
